<?php
#
# Avatar Modification by aldo.
#
# This modifications point is to serve up avatars
# while using the least amount of resources
#

if(!defined('SMF'))
  die;

# We gotta do a bit here. Since SMF uses ; instead of &
# its a bit, different XD
$temp = explode(';', $_SERVER['QUERY_STRING']);
foreach($temp as $tmp)
  if(substr($tmp, 0, 6) == 'attach')
  {
    @list(, $_GET['attach']) = explode('=', $tmp);
    break;
  }

# Don't be a waste of our time!
if(empty($_GET['attach']) || (string)$_GET['attach'] != (string)(int)$_GET['attach'])
  die('Invalid avatar request.');

# All we need is Load.php!
require($sourcedir. '/Load.php');

if(!empty($maintenance) && $maintenance == 2)
  die;

$smcFunc = array();

# Load the database.
loadDatabase();

# Settings...
reloadSettings();

# Do some other *things*
if(!empty($modSettings['enableCompressedOutput']) && !headers_sent() && ob_get_length() == 0)
{
	if(@ini_get('zlib.output_compression') == '1' || @ini_get('output_handler') == 'ob_gzhandler' || @version_compare(PHP_VERSION, '4.2.0') == -1)
		$modSettings['enableCompressedOutput'] = '0';
	else
		ob_start('ob_gzhandler');
}

# Not sent yet..? ._.
if(empty($modSettings['enableCompressedOutput']))
{
	ob_start();
  header('Content-Encoding: none');
}

# What is the attachment number?
$id_attach = (int)$_GET['attach'];

# By any chance, cached?
if(($cache = cache_get_data('avatar_lookup_id-'. $id_attach)) != null)
{
  # :P
  $file = $cache;
}
else
{
  # Sadly, no...
  # It is database querying time!
  $result = $smcFunc['db_query']('', '
    SELECT
      id_folder, filename AS real_filename, fileext, id_attach,
      attachment_type, mime_type, approved AS is_approved, file_hash
    FROM {db_prefix}attachments
    WHERE id_attach = {int:id_attach} AND id_member > 0 AND attachment_type = 0
    LIMIT 1',
    array(
      'id_attach' => $id_attach,
    ));

  # Not doing this would save resources, but hey, seeing as it will
  # only be done every once in awhile, we will do it.
  $smcFunc['db_query']('attach_download_increase', '
    UPDATE LOW_PRIORITY {db_prefix}attachments
    SET downloads = downloads + 1
    WHERE id_attach = {int:id_attach}
    LIMIT 1',
    array(
      'id_attach' => $id_attach,
    ));

  # Now get the information :D
  $file = $smcFunc['db_fetch_assoc']($result);

  # Oh boy... This is bad. We need to get Subs.php for a
  # function to get the files information. Its a big memory
  # sucker too :P
  require($sourcedir. '/Subs.php');

  $file['filename'] = getAttachmentFilename($file['real_filename'], $id_attach, $file['id_folder'], false, $file['file_hash']);

  # ETag time? I think so!
  $file['etag'] = '"'. function_exists('md5_file') ? md5_file($file['filename']) : md5(file_get_contents($file['filename'])). '"';

  # Cache it... (Why do I randomly select a length at which to expire? Search around for RIP_JITTER :P)
  cache_put_data('avatar_lookup_id-'. $id_attach, $file, mt_rand(850, 900));
}

# File not exist? That does us no good!
if(!file_exists($file['filename']))
{
  # Yeah, it didn't exist.
  header('HTTP/1.0 404 File Not Found');

  die('Invalid avatar request.');
}

# You got it in your cache? Fine. Be that way.
if(!empty($_SERVER['HTTP_IF_MODIFIED_SINCE']))
{
  @list($since) = explode(';', $_SERVER['HTTP_IF_MODIFIED_SINCE']);
  if(strtotime($since) >= filemtime($file['filename']))
  {
    header('HTTP/1.1 304 Not Modified');
    exit;
  }
}

if(!empty($_SERVER['HTTP_IF_NONE_MATCH']) && strpos($_SERVER['HTTP_IF_NONE_MATCH'], $file['etag']) !== false)
{
  # Not modified!
  header('HTTP/1.1 304 Not Modified');
  exit;
}

# Now are headers, and we are good to go!
header('Expires: '. gmdate('D, d M Y H:i:s', time() + 31536000). ' GMT'); # Expire in a year. Hehe.
header('Last-Modified: '. gmdate('D, d M Y H:i:s', filemtime($file['filename'])). ' GMT');
header('Accept-Ranges: bytes');
header('Connection: close');
header('ETag: '. $file['etag']);
header('Content-Type: '. $file['mime_type']);

# Now output the file, and we can call it good!
$fp = fopen($file['filename'], 'rb');
while(!feof($fp))
  echo fread($fp, 8192);
fclose($fp);
exit;
?>